<?php
/* use an IMAP server to Authenticate users */
/* use the DB to store Users/Groups informations */
require_once('default.inc.php');
class imapAuth extends defaultAuth {

  function imapAuth() {
    $this->userfields = array('login','password','name','group_name','email','lang','reg_date','regid','active');
    $this->features = array('useradmin' => 'yes', 'groupadmin' => 'yes');
  }

  function init() {
    $this->db = app()->db;
    $this->imap = app()->config['imap'];
  }

  function authenticate($login,$password) {
    $imap_login = @imap_open($this->imap['server'], $login, $password);
    if ($imap_login == false){
        $ret = false;
    }
    else {
        imap_close($imap_login);
        $res = $this->db->read('users',array('login' => $login));
        // First login
        if (count($res)==0){
          $ret = true;
          $this->db->insert('users',array(
                'login' => $login,
                'password' => '',
                'name' => $login,
                'group_name' => $this->imap['default_group'],
                'email' => $login."@".$this->imap['domain'],
                'reg_date' => date('Y-m-d H:i:s'),
                'active' => 1,
          ));
        }
        // User exists in the database
        else{
            $user = $res[0];
            if ($user['active']==1){
                $ret = true;
            }
            else{
                $ret = false;
            }
        }
    }
    return $ret;
  }
}
?>

